<?php
/**
* Membership Level Labels.
*
* Copyright: © 2009-2011
* {@link http://www.optimizepress.com/ optimizePress, Inc.}
* ( coded in the USA )
*
* Released under the terms of the GNU General Public License.
* You should have received a copy of the GNU General Public License,
* along with this software. In the main directory, see: /licensing/
* If not, see: {@link http://www.gnu.org/licenses/}.
*
* @package optimizeMember\Roles_Caps
* @since 3.5
*/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit ("Do not access this file directly.");
/**/
if (!class_exists ("c_ws_plugin__optimizemember_labels"))
	{
		/**
		* Membership Level Labels.
		*
		* @package optimizeMember\Roles_Caps
		* @since 3.5
		*/
		class c_ws_plugin__optimizemember_labels
			{
				/**
				* Configures Label translations.
				*
				* @package optimizeMember\Roles_Caps
				* @since 3.5
				*
				* @attaches-to ``add_action("init");``
				*
				* @return null
				*/
				public static function config_label_translations ()
					{
						do_action ("ws_plugin__optimizemember_before_config_label_translations", get_defined_vars ());
						/**/
						if ($GLOBALS["WS_PLUGIN__"]["optimizemember"]["o"]["apply_label_translations"])
							add_filter ("gettext_with_context", "c_ws_plugin__optimizemember_labels::_label_translations", 10, 3);
						/**/
						do_action ("ws_plugin__optimizemember_after_config_label_translations", get_defined_vars ());
						/**/
						return; /* Return for uniformity. */
					}
				/**
				* A sort of callback function that deals with Label translations.
				*
				* @package optimizeMember\Roles_Caps
				* @since 3.5
				*
				* @attaches-to ``add_filter("gettext_with_context");``
				*
				* @param str $translation Expects a string; already translated.
				* @param str $original The original text, passed in by the Filter.
				* @param str $context Contextual specification for this translation.
				* @return str The ``$translation``, after translations applied by this routine.
				*/
				public static function _label_translations ($translation = FALSE, $original = FALSE, $context = FALSE)
					{
						if ($original && $context && stripos ($context, "User role") === 0 && ($role = $original))
							{
								if (preg_match ("/^(Free )?Subscriber$/i", $role) && !empty ($GLOBALS["WS_PLUGIN__"]["optimizemember"]["o"]["level0_label"]))
									$translation = $GLOBALS["WS_PLUGIN__"]["optimizemember"]["o"]["level0_label"];
								/**/
								else if (preg_match ("/^optimizeMember Level ([0-9]+)$/i", $role, $m) && !empty ($GLOBALS["WS_PLUGIN__"]["optimizemember"]["o"]["level" . $m[1] . "_label"]))
									$translation = $GLOBALS["WS_PLUGIN__"]["optimizemember"]["o"]["level" . $m[1] . "_label"];
								/**/
								$translation = apply_filters ("_ws_plugin__optimizemember_label_translations", $translation, get_defined_vars ());
							}
						/**/
						return $translation; /* Return translation. */
					}
			}
	}
?>