<?php
/**
* Pro login redirections.
*
* Copyright: © 2009-2011
* {@link http://www.optimizepress.com/ optimizePress, Inc.}
* ( coded in the USA )
*
* This WordPress plugin ( optimizeMember Pro ) is comprised of two parts:
*
* o (1) Its PHP code is licensed under the GPL license, as is WordPress.
* 	You should have received a copy of the GNU General Public License,
* 	along with this software. In the main directory, see: /licensing/
* 	If not, see: {@link http://www.gnu.org/licenses/}.
*
* o (2) All other parts of ( optimizeMember Pro ); including, but not limited to:
* 	the CSS code, some JavaScript code, images, and design;
* 	are licensed according to the license purchased.
* 	See: {@link http://www.optimizepress.com/prices/}
*
* Unless you have our prior written consent, you must NOT directly or indirectly license,
* sub-license, sell, resell, or provide for free; part (2) of the optimizeMember Pro Module;
* or make an offer to do any of these things. All of these things are strictly
* prohibited with part (2) of the optimizeMember Pro Module.
*
* Your purchase of optimizeMember Pro includes free lifetime upgrades via optimizeMember.com
* ( i.e. new features, bug fixes, updates, improvements ); along with full access
* to our video tutorial library: {@link http://www.optimizepress.com/videos/}
*
* @package optimizeMember\Login_Redirects
* @since 110720
*/
if (realpath (__FILE__) === realpath ($_SERVER["SCRIPT_FILENAME"]))
	exit("Do not access this file directly.");
/**/
if (!class_exists ("c_ws_plugin__optimizemember_pro_login_redirects"))
	{
		/**
		* Pro login redirections.
		*
		* @package optimizeMember\Login_Redirects
		* @since 110720
		*/
		class c_ws_plugin__optimizemember_pro_login_redirects
			{
				/**
				* Handles Pro login redirections.
				*
				* @package optimizeMember\Login_Redirects
				* @since 110720
				*
				* @attaches-to ``add_filter("ws_plugin__optimizemember_login_redirect");``
				*
				* @param bool|str $redirect Expects a boolean value of true|false, or a non-empty string, passed through by the Filter.
				* @param array $vars Expects an array of defined variables, passed in by the Filter.
				* @return bool|str A One-Time-Offer redirection URL, else the original value.
				*/
				public static function login_redirect ($redirect = FALSE, $vars = FALSE)
					{
						if ($redirect && ($user = $vars["user"]) && ($logins = $vars["logins"]))
							{
								foreach (preg_split ("/[\r\n\t]+/", $GLOBALS["WS_PLUGIN__"]["optimizemember"]["o"]["pro_login_welcome_page_otos"]) as $oto)
									{
										if (($oto = trim ($oto)) && preg_match ("/^(?:([0-9]+)\:)(?:([0-9]+)\:)?(.+)$/", $oto, $m)) /* Proper? */
											{
												list (, $number_of_logins, $level, $url) = $m; /* Assign variables. */
												if ((int)$number_of_logins === (int)$logins) /* One-Time-Offer applies? */
													if (!is_numeric ($level) || c_ws_plugin__optimizemember_user_access::user_access_level ($user) === (int)$level)
														if (($url = c_ws_plugin__optimizemember_login_redirects::fill_login_redirect_rc_vars ($url, $user)))
															return ($redirect = $url);
											}
									}
							}
						/**/
						return $redirect; /* Return ``$redirect`` value. */
					}
			}
	}
?>